Index: /trunk/src/os2ahci/ahci.c
===================================================================
--- /trunk/src/os2ahci/ahci.c	(revision 86)
+++ /trunk/src/os2ahci/ahci.c	(revision 87)
@@ -2,6 +2,11 @@
  * ahci.c - ahci hardware access functions
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
@@ -1582,5 +1587,5 @@
   ai->ports[p].devs[d].removable = (id_buf[ATA_ID_CONFIG] & 0x0080U) != 0;
   ai->ports[p].devs[d].dev_type  = UIB_TYPE_DISK;
-  
+
   if (id_buf[ATA_ID_CONFIG] & 0x8000U) {
     /* this is an ATAPI device; augment device information */
Index: /trunk/src/os2ahci/ahci.h
===================================================================
--- /trunk/src/os2ahci/ahci.h	(revision 86)
+++ /trunk/src/os2ahci/ahci.h	(revision 87)
@@ -2,6 +2,11 @@
  * ahci.h - AHCI-specific constants for os2ahci.h
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
Index: /trunk/src/os2ahci/apm.c
===================================================================
--- /trunk/src/os2ahci/apm.c	(revision 86)
+++ /trunk/src/os2ahci/apm.c	(revision 87)
@@ -2,6 +2,10 @@
  * apm.c - Functions to interface with the APM driver.
  *
- * Copyright (c) 2010 Christian Mueller, Markus Thielen.
- * Parts copied from/inspired by the LINUX ahci driver; 
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
  * those parts are (c) Linux AHCI/ATA maintainers
  *
Index: /trunk/src/os2ahci/ata.c
===================================================================
--- /trunk/src/os2ahci/ata.c	(revision 86)
+++ /trunk/src/os2ahci/ata.c	(revision 87)
@@ -2,6 +2,10 @@
  * ata.c - ATA command processing
  *
- * Copyright (c) 2010 Christian Mueller, Markus Thielen.
- * Parts copied from/inspired by the Linux AHCI driver; 
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
  * those parts are (c) Linux AHCI/ATA maintainers
  *
Index: /trunk/src/os2ahci/ata.h
===================================================================
--- /trunk/src/os2ahci/ata.h	(revision 86)
+++ /trunk/src/os2ahci/ata.h	(revision 87)
@@ -2,6 +2,11 @@
  * ata.h - ATA structures and macros for os2ahci driver
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
@@ -194,114 +199,114 @@
 #define ATA_CMD_IDLE                    0xE3  /* place in idle power mode */
 #define ATA_CMD_EDD                     0x90  /* execute device diagnostic */
-#define ATA_CMD_DOWNLOAD_MICRO          0x92 
-#define ATA_CMD_NOP                     0x00 
-#define ATA_CMD_FLUSH                   0xE7 
-#define ATA_CMD_FLUSH_EXT               0xEA 
-#define ATA_CMD_ID_ATA                  0xEC 
-#define ATA_CMD_ID_ATAPI                0xA1 
-#define ATA_CMD_SERVICE                 0xA2 
-#define ATA_CMD_READ                    0xC8 
-#define ATA_CMD_READ_EXT                0x25 
-#define ATA_CMD_READ_QUEUED             0x26 
-#define ATA_CMD_READ_STREAM_EXT         0x2B 
-#define ATA_CMD_READ_STREAM_DMA_EXT     0x2A 
-#define ATA_CMD_WRITE                   0xCA 
-#define ATA_CMD_WRITE_EXT               0x35 
-#define ATA_CMD_WRITE_QUEUED            0x36 
-#define ATA_CMD_WRITE_STREAM_EXT        0x3B 
-#define ATA_CMD_WRITE_STREAM_DMA_EXT    0x3A 
-#define ATA_CMD_WRITE_FUA_EXT           0x3D 
-#define ATA_CMD_WRITE_QUEUED_FUA_EXT    0x3E 
-#define ATA_CMD_FPDMA_READ              0x60 
-#define ATA_CMD_FPDMA_WRITE             0x61 
-#define ATA_CMD_PIO_READ                0x20 
-#define ATA_CMD_PIO_READ_EXT            0x24 
-#define ATA_CMD_PIO_WRITE               0x30 
-#define ATA_CMD_PIO_WRITE_EXT           0x34 
-#define ATA_CMD_READ_MULTI              0xC4 
-#define ATA_CMD_READ_MULTI_EXT          0x29 
-#define ATA_CMD_WRITE_MULTI             0xC5 
-#define ATA_CMD_WRITE_MULTI_EXT         0x39 
-#define ATA_CMD_WRITE_MULTI_FUA_EXT     0xCE 
-#define ATA_CMD_SET_FEATURES            0xEF 
-#define ATA_CMD_SET_MULTI               0xC6 
-#define ATA_CMD_PACKET                  0xA0 
-#define ATA_CMD_VERIFY                  0x40 
-#define ATA_CMD_VERIFY_EXT              0x42 
-#define ATA_CMD_WRITE_UNCORR_EXT        0x45 
-#define ATA_CMD_STANDBYNOW1             0xE0 
-#define ATA_CMD_IDLEIMMEDIATE           0xE1 
-#define ATA_CMD_SLEEP                   0xE6 
-#define ATA_CMD_INIT_DEV_PARAMS         0x91 
-#define ATA_CMD_READ_NATIVE_MAX         0xF8 
-#define ATA_CMD_READ_NATIVE_MAX_EXT     0x27 
-#define ATA_CMD_SET_MAX                 0xF9 
-#define ATA_CMD_SET_MAX_EXT             0x37 
-#define ATA_CMD_READ_LOG_EXT            0x2F 
-#define ATA_CMD_WRITE_LOG_EXT           0x3F 
-#define ATA_CMD_READ_LOG_DMA_EXT        0x47 
-#define ATA_CMD_WRITE_LOG_DMA_EXT       0x57 
-#define ATA_CMD_TRUSTED_RCV             0x5C 
-#define ATA_CMD_TRUSTED_RCV_DMA         0x5D 
-#define ATA_CMD_TRUSTED_SND             0x5E 
-#define ATA_CMD_TRUSTED_SND_DMA         0x5F 
-#define ATA_CMD_PMP_READ                0xE4 
-#define ATA_CMD_PMP_WRITE               0xE8 
-#define ATA_CMD_CONF_OVERLAY            0xB1 
-#define ATA_CMD_SEC_SET_PASS            0xF1 
-#define ATA_CMD_SEC_UNLOCK              0xF2 
-#define ATA_CMD_SEC_ERASE_PREP          0xF3 
-#define ATA_CMD_SEC_ERASE_UNIT          0xF4 
-#define ATA_CMD_SEC_FREEZE_LOCK         0xF5 
-#define ATA_CMD_SEC_DISABLE_PASS        0xF6 
-#define ATA_CMD_CONFIG_STREAM           0x51 
-#define ATA_CMD_SMART                   0xB0 
-#define ATA_CMD_MEDIA_LOCK              0xDE 
-#define ATA_CMD_MEDIA_UNLOCK            0xDF 
-#define ATA_CMD_DSM                     0x06 
-#define ATA_CMD_CHK_MED_CRD_TYP         0xD1 
-#define ATA_CMD_CFA_REQ_EXT_ERR         0x03 
-#define ATA_CMD_CFA_WRITE_NE            0x38 
-#define ATA_CMD_CFA_TRANS_SECT          0x87 
-#define ATA_CMD_CFA_ERASE               0xC0 
-#define ATA_CMD_CFA_WRITE_MULT_NE       0xCD 
+#define ATA_CMD_DOWNLOAD_MICRO          0x92
+#define ATA_CMD_NOP                     0x00
+#define ATA_CMD_FLUSH                   0xE7
+#define ATA_CMD_FLUSH_EXT               0xEA
+#define ATA_CMD_ID_ATA                  0xEC
+#define ATA_CMD_ID_ATAPI                0xA1
+#define ATA_CMD_SERVICE                 0xA2
+#define ATA_CMD_READ                    0xC8
+#define ATA_CMD_READ_EXT                0x25
+#define ATA_CMD_READ_QUEUED             0x26
+#define ATA_CMD_READ_STREAM_EXT         0x2B
+#define ATA_CMD_READ_STREAM_DMA_EXT     0x2A
+#define ATA_CMD_WRITE                   0xCA
+#define ATA_CMD_WRITE_EXT               0x35
+#define ATA_CMD_WRITE_QUEUED            0x36
+#define ATA_CMD_WRITE_STREAM_EXT        0x3B
+#define ATA_CMD_WRITE_STREAM_DMA_EXT    0x3A
+#define ATA_CMD_WRITE_FUA_EXT           0x3D
+#define ATA_CMD_WRITE_QUEUED_FUA_EXT    0x3E
+#define ATA_CMD_FPDMA_READ              0x60
+#define ATA_CMD_FPDMA_WRITE             0x61
+#define ATA_CMD_PIO_READ                0x20
+#define ATA_CMD_PIO_READ_EXT            0x24
+#define ATA_CMD_PIO_WRITE               0x30
+#define ATA_CMD_PIO_WRITE_EXT           0x34
+#define ATA_CMD_READ_MULTI              0xC4
+#define ATA_CMD_READ_MULTI_EXT          0x29
+#define ATA_CMD_WRITE_MULTI             0xC5
+#define ATA_CMD_WRITE_MULTI_EXT         0x39
+#define ATA_CMD_WRITE_MULTI_FUA_EXT     0xCE
+#define ATA_CMD_SET_FEATURES            0xEF
+#define ATA_CMD_SET_MULTI               0xC6
+#define ATA_CMD_PACKET                  0xA0
+#define ATA_CMD_VERIFY                  0x40
+#define ATA_CMD_VERIFY_EXT              0x42
+#define ATA_CMD_WRITE_UNCORR_EXT        0x45
+#define ATA_CMD_STANDBYNOW1             0xE0
+#define ATA_CMD_IDLEIMMEDIATE           0xE1
+#define ATA_CMD_SLEEP                   0xE6
+#define ATA_CMD_INIT_DEV_PARAMS         0x91
+#define ATA_CMD_READ_NATIVE_MAX         0xF8
+#define ATA_CMD_READ_NATIVE_MAX_EXT     0x27
+#define ATA_CMD_SET_MAX                 0xF9
+#define ATA_CMD_SET_MAX_EXT             0x37
+#define ATA_CMD_READ_LOG_EXT            0x2F
+#define ATA_CMD_WRITE_LOG_EXT           0x3F
+#define ATA_CMD_READ_LOG_DMA_EXT        0x47
+#define ATA_CMD_WRITE_LOG_DMA_EXT       0x57
+#define ATA_CMD_TRUSTED_RCV             0x5C
+#define ATA_CMD_TRUSTED_RCV_DMA         0x5D
+#define ATA_CMD_TRUSTED_SND             0x5E
+#define ATA_CMD_TRUSTED_SND_DMA         0x5F
+#define ATA_CMD_PMP_READ                0xE4
+#define ATA_CMD_PMP_WRITE               0xE8
+#define ATA_CMD_CONF_OVERLAY            0xB1
+#define ATA_CMD_SEC_SET_PASS            0xF1
+#define ATA_CMD_SEC_UNLOCK              0xF2
+#define ATA_CMD_SEC_ERASE_PREP          0xF3
+#define ATA_CMD_SEC_ERASE_UNIT          0xF4
+#define ATA_CMD_SEC_FREEZE_LOCK         0xF5
+#define ATA_CMD_SEC_DISABLE_PASS        0xF6
+#define ATA_CMD_CONFIG_STREAM           0x51
+#define ATA_CMD_SMART                   0xB0
+#define ATA_CMD_MEDIA_LOCK              0xDE
+#define ATA_CMD_MEDIA_UNLOCK            0xDF
+#define ATA_CMD_DSM                     0x06
+#define ATA_CMD_CHK_MED_CRD_TYP         0xD1
+#define ATA_CMD_CFA_REQ_EXT_ERR         0x03
+#define ATA_CMD_CFA_WRITE_NE            0x38
+#define ATA_CMD_CFA_TRANS_SECT          0x87
+#define ATA_CMD_CFA_ERASE               0xC0
+#define ATA_CMD_CFA_WRITE_MULT_NE       0xCD
 /* marked obsolete in the ATA/ATAPI-7 spec */
-#define ATA_CMD_RESTORE                 0x10 
+#define ATA_CMD_RESTORE                 0x10
 
 /* READ_LOG_EXT pages */
-#define ATA_LOG_SATA_NCQ                0x10 
+#define ATA_LOG_SATA_NCQ                0x10
 
 /* READ/WRITE LONG (obsolete) */
-#define ATA_CMD_READ_LONG               0x22 
-#define ATA_CMD_READ_LONG_ONCE          0x23 
-#define ATA_CMD_WRITE_LONG              0x32 
-#define ATA_CMD_WRITE_LONG_ONCE         0x33 
+#define ATA_CMD_READ_LONG               0x22
+#define ATA_CMD_READ_LONG_ONCE          0x23
+#define ATA_CMD_WRITE_LONG              0x32
+#define ATA_CMD_WRITE_LONG_ONCE         0x33
 
 /* SETFEATURES stuff */
-#define SETFEATURES_XFER        0x03 
-#define XFER_UDMA_7             0x47 
-#define XFER_UDMA_6             0x46 
-#define XFER_UDMA_5             0x45 
-#define XFER_UDMA_4             0x44 
-#define XFER_UDMA_3             0x43 
-#define XFER_UDMA_2             0x42 
-#define XFER_UDMA_1             0x41 
-#define XFER_UDMA_0             0x40 
+#define SETFEATURES_XFER        0x03
+#define XFER_UDMA_7             0x47
+#define XFER_UDMA_6             0x46
+#define XFER_UDMA_5             0x45
+#define XFER_UDMA_4             0x44
+#define XFER_UDMA_3             0x43
+#define XFER_UDMA_2             0x42
+#define XFER_UDMA_1             0x41
+#define XFER_UDMA_0             0x40
 #define XFER_MW_DMA_4           0x24  /* CFA only */
 #define XFER_MW_DMA_3           0x23  /* CFA only */
-#define XFER_MW_DMA_2           0x22 
-#define XFER_MW_DMA_1           0x21 
-#define XFER_MW_DMA_0           0x20 
-#define XFER_SW_DMA_2           0x12 
-#define XFER_SW_DMA_1           0x11 
-#define XFER_SW_DMA_0           0x10 
+#define XFER_MW_DMA_2           0x22
+#define XFER_MW_DMA_1           0x21
+#define XFER_MW_DMA_0           0x20
+#define XFER_SW_DMA_2           0x12
+#define XFER_SW_DMA_1           0x11
+#define XFER_SW_DMA_0           0x10
 #define XFER_PIO_6              0x0E  /* CFA only */
 #define XFER_PIO_5              0x0D  /* CFA only */
-#define XFER_PIO_4              0x0C 
-#define XFER_PIO_3              0x0B 
-#define XFER_PIO_2              0x0A 
-#define XFER_PIO_1              0x09 
-#define XFER_PIO_0              0x08 
-#define XFER_PIO_SLOW           0x00 
+#define XFER_PIO_4              0x0C
+#define XFER_PIO_3              0x0B
+#define XFER_PIO_2              0x0A
+#define XFER_PIO_1              0x09
+#define XFER_PIO_0              0x08
+#define XFER_PIO_SLOW           0x00
 
 #define SETFEATURES_WC_ON       0x02  /* Enable write cache */
@@ -309,6 +314,6 @@
 
 /* Enable/Disable Automatic Acoustic Management */
-#define SETFEATURES_AAM_ON      0x42 
-#define SETFEATURES_AAM_OFF     0xC2 
+#define SETFEATURES_AAM_ON      0x42
+#define SETFEATURES_AAM_OFF     0xC2
 
 #define SETFEATURES_SPINUP      0x07  /* Spin-up drive */
@@ -326,30 +331,30 @@
 
 /* feature values for SET_MAX */
-#define ATA_SET_MAX_ADDR        0x00 
-#define ATA_SET_MAX_PASSWD      0x01 
-#define ATA_SET_MAX_LOCK        0x02 
-#define ATA_SET_MAX_UNLOCK      0x03 
-#define ATA_SET_MAX_FREEZE_LOCK 0x04 
+#define ATA_SET_MAX_ADDR        0x00
+#define ATA_SET_MAX_PASSWD      0x01
+#define ATA_SET_MAX_LOCK        0x02
+#define ATA_SET_MAX_UNLOCK      0x03
+#define ATA_SET_MAX_FREEZE_LOCK 0x04
 
 /* feature values for DEVICE CONFIGURATION OVERLAY */
-#define ATA_DCO_RESTORE         0xC0 
-#define ATA_DCO_FREEZE_LOCK     0xC1 
-#define ATA_DCO_IDENTIFY        0xC2 
-#define ATA_DCO_SET             0xC3 
+#define ATA_DCO_RESTORE         0xC0
+#define ATA_DCO_FREEZE_LOCK     0xC1
+#define ATA_DCO_IDENTIFY        0xC2
+#define ATA_DCO_SET             0xC3
 
 /* feature values for SMART */
-#define ATA_SMART_ENABLE        0xD8 
-#define ATA_SMART_READ_VALUES   0xD0 
-#define ATA_SMART_READ_THRESHOLDS 0xD1 
+#define ATA_SMART_ENABLE        0xD8
+#define ATA_SMART_READ_VALUES   0xD0
+#define ATA_SMART_READ_THRESHOLDS 0xD1
 
 /* feature values for Data Set Management */
-#define ATA_DSM_TRIM            0x01 
+#define ATA_DSM_TRIM            0x01
 
 /* password used in LBA Mid / LBA High for executing SMART commands */
-#define ATA_SMART_LBAM_PASS     0x4F 
-#define ATA_SMART_LBAH_PASS     0xC2 
+#define ATA_SMART_LBAM_PASS     0x4F
+#define ATA_SMART_LBAH_PASS     0xC2
 
 /* ATAPI stuff */
-#define ATAPI_PKT_DMA           (1U << 0) 
+#define ATAPI_PKT_DMA           (1U << 0)
 #define ATAPI_DMADIR            (1U << 2)      /* ATAPI data dir:
                                                   0=to device, 1=to host */
Index: /trunk/src/os2ahci/atapi.c
===================================================================
--- /trunk/src/os2ahci/atapi.c	(revision 86)
+++ /trunk/src/os2ahci/atapi.c	(revision 87)
@@ -2,6 +2,10 @@
  * atapi.c - ATAPI command processing
  *
- * Copyright (c) 2010 Christian Mueller, Markus Thielen. 
- * Parts copied from/inspired by the Linux AHCI driver; 
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
  * those parts are (c) Linux AHCI/ATA maintainers
  *
@@ -105,5 +109,5 @@
     }
   } while (rc > 0 && sg_cnt > 0);
-    
+
   if (rc == 0) {
     add_workspace(iorb)->blocks = count;
@@ -180,5 +184,5 @@
     iorb_seterr(iorb, IOERR_DEVICE_NONSPECIFIC);
   }
-  
+
   return(rc);
 }
@@ -234,5 +238,5 @@
   pcdb->cmd = ATAPI_CMD_REQUEST_SENSE;
   pcdb->trans_len = (u8) sense_buf_len;
-  
+
   aws->ppfunc = atapi_req_sense_pp;
   rc = ata_cmd(ad_infos + iorb_unit_adapter(iorb),
@@ -327,5 +331,5 @@
     iorb_seterr(iorb, IOERR_CMD_ABORTED);
     break;
-  
+
   default:
     iorb_seterr(iorb, IOERR_DEVICE_NONSPECIFIC);
@@ -344,5 +348,5 @@
  * returns 0 on success, != 0 if the command can't be converted.
  */
-int atapi_pad_cdb(u8 _far *cmd_in, u16 cmd_in_len, 
+int atapi_pad_cdb(u8 _far *cmd_in, u16 cmd_in_len,
                   u8 _far *cmd_out, u16 _far *cmd_out_len)
 {
Index: /trunk/src/os2ahci/atapi.h
===================================================================
--- /trunk/src/os2ahci/atapi.h	(revision 86)
+++ /trunk/src/os2ahci/atapi.h	(revision 87)
@@ -2,6 +2,10 @@
  * atapi.h - ATAPI structures and macros for os2ahci driver
  *
- * Copyright (c) 2010 Christian Mueller, Markus Thielen. 
- * Parts copied from/inspired by the  Linux AHCI driver; 
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
  * those parts are (c) Linux AHCI/ATA maintainers
  *
Index: /trunk/src/os2ahci/ctxhook.c
===================================================================
--- /trunk/src/os2ahci/ctxhook.c	(revision 86)
+++ /trunk/src/os2ahci/ctxhook.c	(revision 87)
@@ -2,6 +2,11 @@
  * ctxhook.c - context hooks (kernel thread functions) for os2ahci
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
@@ -49,5 +54,5 @@
 /******************************************************************************
  * Port restart context hook. This context hook is executed at task time and
- * will handle ports which are stopped due to a device error condition. 
+ * will handle ports which are stopped due to a device error condition.
  *
  * The following conditions may exist:
@@ -257,5 +262,5 @@
  *                       execution. This is primarily used for timeout
  *                       handling and when IORBs are requested to be aborted.
- * 
+ *
  * After resetting the requested ports, all remaining active IORBs on those
  * ports have to be retried or aborted. Whether a retry is attempted depends
@@ -332,5 +337,5 @@
          * release the spinlock while doing so. The adapter is marked as
          * 'busy' to prevent similar routines (e.g. an ahci port scan) from
-         * interfering. 
+         * interfering.
          */
         ai->busy = 1;
Index: /trunk/src/os2ahci/ioctl.c
===================================================================
--- /trunk/src/os2ahci/ioctl.c	(revision 86)
+++ /trunk/src/os2ahci/ioctl.c	(revision 87)
@@ -2,6 +2,11 @@
  * ioctl.c - Generic IOCTL command processing
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
@@ -221,5 +226,5 @@
    * so we can use spinlocks to protect the time between checking the
    * IORB_DONE flag and calling ProcBlock.
-   * 
+   *
    * However, if OS2AHCI_SMP is not defined, we're emulating spinlocks
    * via disabling interrupts and there's a sanity check in the emulation
Index: /trunk/src/os2ahci/ioctl.h
===================================================================
--- /trunk/src/os2ahci/ioctl.h	(revision 86)
+++ /trunk/src/os2ahci/ioctl.h	(revision 87)
@@ -2,6 +2,11 @@
  * ioctl.h - IOCTL structures and constants for os2ahci driver
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
Index: /trunk/src/os2ahci/libc.c
===================================================================
--- /trunk/src/os2ahci/libc.c	(revision 86)
+++ /trunk/src/os2ahci/libc.c	(revision 87)
@@ -2,6 +2,11 @@
  * libc.c - minimal subset of C runtime library for os2ahci
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
Index: /trunk/src/os2ahci/os2ahci.c
===================================================================
--- /trunk/src/os2ahci/os2ahci.c	(revision 86)
+++ /trunk/src/os2ahci/os2ahci.c	(revision 87)
@@ -2,6 +2,11 @@
  * os2ahci.c - main file for os2ahci driver
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
@@ -108,6 +113,4 @@
 static char     init_msg[] = "OS2AHCI driver version %d.%02d\n";
 static char     exit_msg[] = "OS2AHCI driver *not* installed\n";
-static char     eval_msg[] = ANSI_CLR_RED ANSI_CLR_BRIGHT "Evaluation version "
-                             "- not licensed for production use.\n" ANSI_RESET;
 
 /* ----------------------------- start of code ----------------------------- */
@@ -173,5 +176,4 @@
   /* print initialization message */
   cprintf(init_msg, VERSION / 100, VERSION % 100);
-  cprintf(eval_msg);
 
   /* register driver with resource manager */
@@ -366,5 +368,5 @@
     case OS2AHCI_IOCTL_GET_DEVLIST:
       return(ioctl_get_devlist(ioctl));
-   
+
     case OS2AHCI_IOCTL_PASSTHROUGH:
       return(ioctl_passthrough(ioctl));
@@ -834,5 +836,5 @@
   dt->ADDHandle     = add_handle;
   dt->TotalAdapters = ad_info_cnt + 1;
-   
+
   /* set start of adapter and device information tables */
   pos = (char _far *) (dt->pAdapter + dt->TotalAdapters);
Index: /trunk/src/os2ahci/os2ahci.h
===================================================================
--- /trunk/src/os2ahci/os2ahci.h	(revision 86)
+++ /trunk/src/os2ahci/os2ahci.h	(revision 87)
@@ -2,6 +2,11 @@
  * os2ahci.h - main header file for os2ahci driver
  *
- * Copyright (c) 2010 Christian Mueller. Parts copied from/inspired by the
- * Linux AHCI driver; those parts are (c) Linux AHCI/ATA maintainers
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
+ * those parts are (c) Linux AHCI/ATA maintainers
  *
  *  This program is free software; you can redistribute it and/or modify
Index: /trunk/src/os2ahci/pci.c
===================================================================
--- /trunk/src/os2ahci/pci.c	(revision 86)
+++ /trunk/src/os2ahci/pci.c	(revision 87)
@@ -2,6 +2,10 @@
  * PCI.c - PCI constants and detection code for os2ahci driver
  *
- * Copyright (c) 2010 Christian Mueller, Markus Thielen.
- * Parts copied from/inspired by the LINUX ahci driver; 
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ * Parts copied from/inspired by the Linux AHCI driver;
  * those parts are (c) Linux AHCI/ATA maintainers
  *
@@ -479,5 +483,5 @@
           }
         }
-            
+
         if (already_found || (ad_ignore & (1U << ad_indx++))) {
           /* ignore this device; it has either already been found via a
@@ -676,5 +680,5 @@
   for (i = 0; i < sizeof(ad_info->rm_bars) / sizeof(*ad_info->rm_bars); i++) {
     long len = bar_resource(bus, dev_func, &resource, i);
-    
+
     if (len < 0) {
       /* something went wrong */
Index: /trunk/src/os2ahci/version.h
===================================================================
--- /trunk/src/os2ahci/version.h	(revision 86)
+++ /trunk/src/os2ahci/version.h	(revision 87)
@@ -1,10 +1,15 @@
 /******************************************************************************
-
-  version.h - define version numbers and strings for OS2AHCI.ADD
-
-  NOTE: this is kept in a separate file for easier parsing by
-        bldlvl.cmd (which creates the bldlevel signature)
-
-******************************************************************************/
+ * version.h - define version numbers and strings for OS2AHCI.ADD
+ *
+ * Copyright (c) 2011 thi.guten Software Development
+ * Copyright (c) 2011 Mensys B.V.
+ *
+ * Authors: Christian Mueller, Markus Thielen
+ *
+ *
+ * NOTE: this is kept in a separate file for easier parsing by
+ *       bldlvl.cmd (which creates the bldlevel signature)
+ *
+ */
 
 