Index: trunk/gui/printer/cupswiz/cupswzeit.mkm
===================================================================
--- trunk/gui/printer/cupswiz/cupswzeit.mkm	(revision 89)
+++ 	(revision )
@@ -1,153 +1,0 @@
-; File Messaggi per CUPSWIZ
-; Versione italiana
-CWZ
-; Common strings
-CWZ0001I: Crea stampante CUPS
-CWZ0002I: OK
-CWZ0003I: Cancella
-CWZ0004I: ~Guida
-CWZ0005I: ~Avanti >
-CWZ0006I: Agg~iorna
-CWZ0007?:
-CWZ0008?:
-CWZ0009?:
-;
-; Product information dialog
-CWZ0010I: Informazioni sul Prodotto
-CWZ0011I: Programma di Installazione Stampanti eCups
-CWZ0012I: Versione %1
-CWZ0013I: (C) %1 Alex Taylor
-CWZ0014I: Volume di avvio del Sistema: %1
-CWZ0015I: Cartella CUPS locale: %1
-CWZ0016I: Archivio dei Driver locali: %1
-CWZ0017?:
-CWZ0018?:
-CWZ0019?:
-;
-; Page 1 messages
-CWZ0020I: Recupero l'elenco delle stampanti supportate. Attendere prego...
-CWZ0021I: Selezionare il produttore e il modello della stampante dall'elenco sottostante.
-CWZ0022I: -- Personalizzata --
-CWZ0023I: -- Altra stampante (richiesto PPD) --
-CWZ0024I: Selezionare PPD
-CWZ0025?:
-CWZ0026I: Impossibile comunicare con il servizio CUPS. Assicurarsi che il Demone CUPS (CUPSD) sia in esecuzione.
-CWZ0027I: Nessun Demone CUPS
-CWZ0028I: Percorso CUPS non trovato o non valido
-CWZ0029I: Stampante selezionata:  %1
-;
-; Page 2 messages
-CWZ0030I: Ricerca di stampanti collegate. Attendere prego...
-CWZ0031I: Selezionare la connessione per questa stampante.
-CWZ0032I: Trovata stampante di rete (%1) "%2" a %3
-CWZ0033I: Trovata stampante di rete %1 a %2
-CWZ0034I: Rete o Altra Stampante (configurazione manuale)
-CWZ0035I: Stampante locale: %1
-CWZ0036?:
-CWZ0037?:
-CWZ0038?:
-CWZ0039?:
-;
-; Page 3 messages
-CWZ0040I: Scegliere il nome della stampante, e inserire la sua posizione e una breve descrizione.
-CWZ0041I: Inserire una breve descrizione per questa stampante. Questa verr
- usata come nome dell'Oggetto Stampante che verr
- creato sulla propria Scrivania.
-CWZ0042I: Ô necessario inserire una descrizione.
-CWZ0043I: Ô necessario inserire un nome, una posizione e una descrizione.
-CWZ0044I: Il nome della stampante deve cominciare con una lettera, e non deve avere caratteri "/", "#", spazi o tabulazioni.
-CWZ0045I: Nome non valido
-CWZ0046?:
-CWZ0047?:
-CWZ0048?:
-CWZ0049?:
-;
-; Page 4
-CWZ0050I: Creazione della stampante...
-CWZ0051I: La stampante  stata creata.
-CWZ0052I: La stampante non pu essere creata.
-CWZ0053I: Crearne un'altra
-CWZ0054I: Indietro
-CWZ0055I: Chiudi
-CWZ0056I: Errore nella creazione della stampante
-CWZ0057I: Driver non trovato
-CWZ0058I: Problema con il Driver della Porta
-CWZ0059I: Inserire Cartella
-;
-; Error & warning messages
-CWZ0060I: Si  verificato il seguente errore nel tentativo di creare la stampante:
-CWZ0061I: Impossibile trovare il driver della stampante %1. Se si dispone del file del driver copiarlo nella cartella %2 e riprovare.
-CWZ0062I: La versione installata di CUPS.PDR sembra essere obsoleta. Di conseguenza le funzionalit
- di stampa dell'Oggetto Stampante non saranno disponibili finch non verr
- riavviata.
-CWZ0063I: Impossibile trovare i file di installazione per il driver %1. Questi verranno ricreati a partire dai file del driver che sono gi
- installati sul proprio sistema.
-CWZ0064I: Scegliere la cartella dove verranno copiati i file di installazione.
-CWZ0065I: Impossibile trovare CUPS. Se si intende usare una versione locale di CUPS,  necessario specificare sulla linea di comando di questo programma il percorso dove CUPS  installato (ad esempio "%1").
-CWZ0066I: Per le stampanti create in questa sessione saranno disponibili soltanto le Code Remote di CUPS (per non visualizzare pi questo avviso in futuro, avviare questo programma con il parametro /R).
-CWZ0067I: Sembra che il driver PM %2 non contenga informazioni su "%1" o su modelli simili. Il driver PostScript genericao verr
- usato per compatibilit
- con il programma.
-CWZ0068I: Nome della Stampante non trovato
-CWZ0069I: Impossibile importare i parametri della stampante, probabilmente a causa di un file PPD incompatibile.
-CWZ0070I: Errore nell'importazione del File PPD
-CWZ0071I: Errore nella Creazione della stampante CUPS. Consultare %1 per maggiori informazioni.
-CWZ0072I: Errore nella Creazione dell'Oggetto Stampante. Consultare %1 per maggiori informazioni.
-CWZ0073I: errore sconosciuto.
-CWZ0074I: Valore(i) Richiesto(i) Mancante(i)
-CWZ0075I: Valore(i) Mancante(i)
-CWZ0076I: Impossibile leggere il nome della stampante da %1.
-CWZ0077I: PPD non valido
-CWZ0078I: Il programma richiesto %1 non  installato. Controllare la propria installazione o contattare il supporto.
-CWZ0079I: File Mancante
-;
-; Network settings dialog
-CWZ0080I: Stampante di Rete
-CWZ0081I: Protocollo di Rete:
-CWZ0082I: Indirizzo Stampante o Server:
-CWZ0083I: Nome del Server di Stampa:
-CWZ0084I: Nome della Coda di Stampa:
-CWZ0085I: Nome della Stampante Condivisa:
-CWZ0086I: ID Utente:
-CWZ0087I: ID Utente (se richiesto):
-CWZ0088I: Nome del Server CUPS:
-CWZ0089I: Nome della Stampante CUPS:
-CWZ0090I: Password:
-CWZ0091I: Stampante CUPS esistente (server remoto)
-CWZ0092I: Protocollo di Stampa Internet (IPP)
-CWZ0093I: AppSocket/JetDirect
-CWZ0094I: Line Printer Remote daemon (LPD)
-CWZ0095I: Rete Windows/SMB
-CWZ0096I: Stampante CUPS esistente
-CWZ0097?:
-CWZ0098?:
-CWZ0099?:
-;
-; Confirmation dialog and Page 3 labels
-CWZ0100I: Pronto a creare la Stampante CUPS con i seguenti parametri.
-CWZ0101I: Pronto a creare l'Oggetto Stampante con i seguenti parametri.
-CWZ0102I: Modello:
-CWZ0103I: Nome:
-CWZ0104I: URI:
-CWZ0105I: Posizione:
-CWZ0106I: Descrizione:
-CWZ0107I: Server CUPS:
-CWZ0108I: Coda CUPS:
-CWZ0109I: Creare Oggetto Stampante
-CWZ0110I: Driver PM:
-CWZ0111I: Creare
-CWZ0112I: Non  installato alcun driver OS/2 PM compatibile con eCups.
-CWZ0113I: Installare il driver di stampante ECUPS o ECUPS-HP prima di continuare.
-CWZ0114I: Driver PM OS/2 mancante
-CWZ0115I: Conferma Creazione Stampante
-CWZ0116?:
-CWZ0117?:
-CWZ0118?:
-CWZ0119?:
-;
-; Model disambiguation dialog
-CWZ0120I: Selezionare il Modello della Stampante
-CWZ0121I: Impossibile trovare la stampante con il nome "%1" nel driver %2.DRV. Scegliere il modello di stampante che verr
- riportato ai programmi.
-CWZ0122I: Ô possibile selezionare uno dei seguenti driver suggeriti, o scegliere 'Cancella' per usare un Driver Generico.
-
Index: trunk/gui/printer/cupswiz/cupswzit.mkm
===================================================================
--- trunk/gui/printer/cupswiz/cupswzit.mkm	(revision 90)
+++ trunk/gui/printer/cupswiz/cupswzit.mkm	(revision 90)
@@ -0,0 +1,153 @@
+; File Messaggi per CUPSWIZ
+; Versione italiana
+CWZ
+; Common strings
+CWZ0001I: Crea stampante CUPS
+CWZ0002I: OK
+CWZ0003I: Cancella
+CWZ0004I: ~Guida
+CWZ0005I: ~Avanti >
+CWZ0006I: Agg~iorna
+CWZ0007?:
+CWZ0008?:
+CWZ0009?:
+;
+; Product information dialog
+CWZ0010I: Informazioni sul Prodotto
+CWZ0011I: Programma di Installazione Stampanti eCups
+CWZ0012I: Versione %1
+CWZ0013I: (C) %1 Alex Taylor
+CWZ0014I: Volume di avvio del Sistema: %1
+CWZ0015I: Cartella CUPS locale: %1
+CWZ0016I: Archivio dei Driver locali: %1
+CWZ0017?:
+CWZ0018?:
+CWZ0019?:
+;
+; Page 1 messages
+CWZ0020I: Recupero l'elenco delle stampanti supportate. Attendere prego...
+CWZ0021I: Selezionare il produttore e il modello della stampante dall'elenco sottostante.
+CWZ0022I: -- Personalizzata --
+CWZ0023I: -- Altra stampante (richiesto PPD) --
+CWZ0024I: Selezionare PPD
+CWZ0025?:
+CWZ0026I: Impossibile comunicare con il servizio CUPS. Assicurarsi che il Demone CUPS (CUPSD) sia in esecuzione.
+CWZ0027I: Nessun Demone CUPS
+CWZ0028I: Percorso CUPS non trovato o non valido
+CWZ0029I: Stampante selezionata:  %1
+;
+; Page 2 messages
+CWZ0030I: Ricerca di stampanti collegate. Attendere prego...
+CWZ0031I: Selezionare la connessione per questa stampante.
+CWZ0032I: Trovata stampante di rete (%1) "%2" a %3
+CWZ0033I: Trovata stampante di rete %1 a %2
+CWZ0034I: Rete o Altra Stampante (configurazione manuale)
+CWZ0035I: Stampante locale: %1
+CWZ0036?:
+CWZ0037?:
+CWZ0038?:
+CWZ0039?:
+;
+; Page 3 messages
+CWZ0040I: Scegliere il nome della stampante, e inserire la sua posizione e una breve descrizione.
+CWZ0041I: Inserire una breve descrizione per questa stampante. Questa verr
+ usata come nome dell'Oggetto Stampante che verr
+ creato sulla propria Scrivania.
+CWZ0042I: Ô necessario inserire una descrizione.
+CWZ0043I: Ô necessario inserire un nome, una posizione e una descrizione.
+CWZ0044I: Il nome della stampante deve cominciare con una lettera, e non deve avere caratteri "/", "#", spazi o tabulazioni.
+CWZ0045I: Nome non valido
+CWZ0046?:
+CWZ0047?:
+CWZ0048?:
+CWZ0049?:
+;
+; Page 4
+CWZ0050I: Creazione della stampante...
+CWZ0051I: La stampante  stata creata.
+CWZ0052I: La stampante non pu essere creata.
+CWZ0053I: Crearne un'altra
+CWZ0054I: Indietro
+CWZ0055I: Chiudi
+CWZ0056I: Errore nella creazione della stampante
+CWZ0057I: Driver non trovato
+CWZ0058I: Problema con il Driver della Porta
+CWZ0059I: Inserire Cartella
+;
+; Error & warning messages
+CWZ0060I: Si  verificato il seguente errore nel tentativo di creare la stampante:
+CWZ0061I: Impossibile trovare il driver della stampante %1. Se si dispone del file del driver copiarlo nella cartella %2 e riprovare.
+CWZ0062I: La versione installata di CUPS.PDR sembra essere obsoleta. Di conseguenza le funzionalit
+ di stampa dell'Oggetto Stampante non saranno disponibili finch non verr
+ riavviata.
+CWZ0063I: Impossibile trovare i file di installazione per il driver %1. Questi verranno ricreati a partire dai file del driver che sono gi
+ installati sul proprio sistema.
+CWZ0064I: Scegliere la cartella dove verranno copiati i file di installazione.
+CWZ0065I: Impossibile trovare CUPS. Se si intende usare una versione locale di CUPS,  necessario specificare sulla linea di comando di questo programma il percorso dove CUPS  installato (ad esempio "%1").
+CWZ0066I: Per le stampanti create in questa sessione saranno disponibili soltanto le Code Remote di CUPS (per non visualizzare pi questo avviso in futuro, avviare questo programma con il parametro /R).
+CWZ0067I: Sembra che il driver PM %2 non contenga informazioni su "%1" o su modelli simili. Il driver PostScript genericao verr
+ usato per compatibilit
+ con il programma.
+CWZ0068I: Nome della Stampante non trovato
+CWZ0069I: Impossibile importare i parametri della stampante, probabilmente a causa di un file PPD incompatibile.
+CWZ0070I: Errore nell'importazione del File PPD
+CWZ0071I: Errore nella Creazione della stampante CUPS. Consultare %1 per maggiori informazioni.
+CWZ0072I: Errore nella Creazione dell'Oggetto Stampante. Consultare %1 per maggiori informazioni.
+CWZ0073I: errore sconosciuto.
+CWZ0074I: Valore(i) Richiesto(i) Mancante(i)
+CWZ0075I: Valore(i) Mancante(i)
+CWZ0076I: Impossibile leggere il nome della stampante da %1.
+CWZ0077I: PPD non valido
+CWZ0078I: Il programma richiesto %1 non  installato. Controllare la propria installazione o contattare il supporto.
+CWZ0079I: File Mancante
+;
+; Network settings dialog
+CWZ0080I: Stampante di Rete
+CWZ0081I: Protocollo di Rete:
+CWZ0082I: Indirizzo Stampante o Server:
+CWZ0083I: Nome del Server di Stampa:
+CWZ0084I: Nome della Coda di Stampa:
+CWZ0085I: Nome della Stampante Condivisa:
+CWZ0086I: ID Utente:
+CWZ0087I: ID Utente (se richiesto):
+CWZ0088I: Nome del Server CUPS:
+CWZ0089I: Nome della Stampante CUPS:
+CWZ0090I: Password:
+CWZ0091I: Stampante CUPS esistente (server remoto)
+CWZ0092I: Protocollo di Stampa Internet (IPP)
+CWZ0093I: AppSocket/JetDirect
+CWZ0094I: Line Printer Remote daemon (LPD)
+CWZ0095I: Rete Windows/SMB
+CWZ0096I: Stampante CUPS esistente
+CWZ0097?:
+CWZ0098?:
+CWZ0099?:
+;
+; Confirmation dialog and Page 3 labels
+CWZ0100I: Pronto a creare la Stampante CUPS con i seguenti parametri.
+CWZ0101I: Pronto a creare l'Oggetto Stampante con i seguenti parametri.
+CWZ0102I: Modello:
+CWZ0103I: Nome:
+CWZ0104I: URI:
+CWZ0105I: Posizione:
+CWZ0106I: Descrizione:
+CWZ0107I: Server CUPS:
+CWZ0108I: Coda CUPS:
+CWZ0109I: Creare Oggetto Stampante
+CWZ0110I: Driver PM:
+CWZ0111I: Creare
+CWZ0112I: Non  installato alcun driver OS/2 PM compatibile con eCups.
+CWZ0113I: Installare il driver di stampante ECUPS o ECUPS-HP prima di continuare.
+CWZ0114I: Driver PM OS/2 mancante
+CWZ0115I: Conferma Creazione Stampante
+CWZ0116?:
+CWZ0117?:
+CWZ0118?:
+CWZ0119?:
+;
+; Model disambiguation dialog
+CWZ0120I: Selezionare il Modello della Stampante
+CWZ0121I: Impossibile trovare la stampante con il nome "%1" nel driver %2.DRV. Scegliere il modello di stampante che verr
+ riportato ai programmi.
+CWZ0122I: Ô possibile selezionare uno dei seguenti driver suggeriti, o scegliere 'Cancella' per usare un Driver Generico.
+